# AdventOfCode2020

My (attempted) solutions to [Advent of Code 2020](https://adventofcode.com/2020) in Elixir.

<img width="978" alt="image" src="https://user-images.githubusercontent.com/498229/103139031-545cf780-471b-11eb-9c94-95c49a1391ba.png">

## Strategy

If this year is like 2018, the last time I did this, each problem will be split into two parts.
The second part can result in considerable refactoring of the first part, so I will split each part into its own file, like this:

* `day1/`
  * `day1part1.exs` - solution to part 1
  * `day1part2.exs` - solution to part 2
  * `README` - my summary and notes relating to the day's problem
  * `input` - input file downloaded from Advent of Code (if applicable)

If I get stuck, my instinct is to be persistent and take as long as it takes to solve the problem.
However I think this year I don't want the pressure of days piling up and this is supposed to be fun,
so I will probably limit each problem to one day, and then come back to those that I had problems with later.

**No checking other people's solutions** until I've solved it myself - or otherwise given up.
If I make any refinements as a result of seeing other people's solutions or reading forums, etc., I will
commit them to a separate file to leave the original version in tact.
